// Options.h

#define STR_LONG    256
#define STR_SHORT   128

#define DEF_PREFS  "PROGDIR:FBackNGUI.prefs"

typedef struct Options {
    char source[STR_LONG];
    char dest[STR_LONG];
    char log[STR_LONG];
    char packer[STR_SHORT];
    char from[STR_SHORT];
    char to[STR_SHORT];
    char pattern[STR_SHORT];
    int  verbosity;
    int  priority;
    BOOL backup;
    BOOL mirror;
    BOOL delete;
    BOOL recursive;
    BOOL touch;
    BOOL simulate;
    BOOL every;
    BOOL notes;
    BOOL narchiv;
} OPTS;

